/* RELATIVE.CPP - Programmed by Maarten Hofman */
/* 040804: Started programming */
/* 060804: Added FIXED_CAMERA */

#include "config.h"
#include "relative.h"

extern int cf;
int calculate_segment(float xp,float zp,float xc,float zc,int real=0) {
float nx,nz,hnx,hnz;

#ifdef FIXED_CAMERA
  if(!real) return cf;
#endif

  nx=xc-xp;
  nz=zc-zp;
  hnx=nx/2.0f;
  hnz=nz/2.0f;
  if(nz<0.0f) if((nx>hnz)&&(nx<-hnz)) return 0;
  if(nx>0.0f) if((nz<hnx)&&(nz>-hnx)) return 6;
  if((nz<0.0f)&&(nx>0.0f)) return 7;
  if(nz>0.0f) if((nx<hnz)&&(nx>-hnz)) return 4;
  if((nz>0.0f)&&(nx>0.0f)) return 5;
  if(nx<0.0f) if((nz>hnx)&&(nz<-hnx)) return 2;
  if(nz>0.0f) return 3;
  return 1;
}

int calculate_direction(float x,float y) {
  if(x>0.3f) {
    if(y>0.3f) return 3;
    if(y<-0.3f) return 1;
    return 2;
  }
  if(x<-0.3f) {
    if(y>0.3f) return 5;
    if(y<-0.3f) return 7;
    return 6;
  }
  if(y>0.3f) return 4;
  if(y<-0.3f) return 0;
  return -1;
}

char *translate_direction(int dir) {
  switch(dir) {
    case 0:
    case 8:
      return "south\n";
    case 1:
    case 9:
      return "southwest\n";
    case 2:
    case 10:
      return "west\n";
    case 3:
    case 11:
      return "northwest\n";
    case 4:
    case 12:
      return "north\n";
    case 5:
    case 13:
      return "northeast\n";
    case 6:
    case 14:
      return "east\n";
    case 7:
    case 15:
      return "southeast\n";
  }
  return "";
}

bool check_camera(Vector3 *vCamEye,float x,float y,float z) {
float distance1,distance;
int segment;

#ifdef FIXED_CAMERA
  vCamEye->x=x-0.5f;
  vCamEye->y=y+30.0f;
  vCamEye->z=z-0.5f;
  switch(cf) {
    case 0:
      vCamEye->z-=20.0f;
      break;
    case 1:
      vCamEye->z-=14.0f;
      vCamEye->x-=14.0f;
      break;
    case 2:
      vCamEye->x-=20.0f;
      break;
    case 3:
      vCamEye->x-=14.0f;
      vCamEye->z+=14.0f;
      break;
    case 4:
      vCamEye->z+=20.0f;
      break;
    case 5:
      vCamEye->z+=14.0f;
      vCamEye->x+=14.0f;
      break;
    case 6:
      vCamEye->x+=20.0f;
      break;
    case 7:
      vCamEye->x+=14.0f;
      vCamEye->z-=14.0f;
  }
  return true;
#endif
  distance1=(vCamEye->x-x)*(vCamEye->x-x)+(vCamEye->z-z)*(vCamEye->z-z);
  distance=distance1+(vCamEye->z-z)*(vCamEye->z-z);
#ifdef RELATIVE_MOVES
  if(distance1<32.0f) {
    segment=calculate_segment(x,z,vCamEye->x,vCamEye->z);
    vCamEye->x=x-0.5f;
    vCamEye->y=y+30.0f;
    vCamEye->z=z-0.5f;
    switch(segment) {
      case 0:
        vCamEye->z+=10.0f;
        break;
      case 1:
        vCamEye->z+=7.0f;
        vCamEye->x+=7.0f;
        break;
      case 2:
        vCamEye->x+=10.0f;
        break;
      case 3:
        vCamEye->x+=7.0f;
        vCamEye->z-=7.0f;
        break;
      case 4:
        vCamEye->z-=10.0f;
        break;
      case 5:
        vCamEye->z-=7.0f;
        vCamEye->x-=7.0f;
        break;
      case 6:
        vCamEye->x-=10.0f;
        break;
      case 7:
        vCamEye->x-=7.0f;
        vCamEye->z+=7.0f;
    }
    return true;
  }
#endif
  if(distance>1800.0f) {
#ifdef RELATIVE_MOVES
    segment=calculate_segment(x,z,vCamEye->x,vCamEye->z);
#endif
    vCamEye->x=x+0.5f;
    vCamEye->y=y+30.0f;
    vCamEye->z=z+0.5f;
#ifdef RELATIVE_MOVES
    switch(segment) {
      case 0:
        vCamEye->z-=7.0f;
        break;
      case 1:
        vCamEye->z-=5.0f;
        vCamEye->x-=5.0f;
        break;
      case 2:
        vCamEye->x-=7.0f;
        break;
      case 3:
        vCamEye->x-=5.0f;
        vCamEye->z+=5.0f;
        break;
      case 4:
        vCamEye->z+=7.0f;
        break;
      case 5:
        vCamEye->z+=5.0f;
        vCamEye->x+=5.0f;
        break;
      case 6:
        vCamEye->x+=7.0f;
        break;
      case 7:
        vCamEye->x+=5.0f;
        vCamEye->z-=5.0f;
    }
#endif
    return true;
  }
  return false;
}

